# N3 FrostFS side chain privnet service
A single-node N3 privnet deployment, running on
[neo-go](https://github.com/nspcc-dev/neo-go). Represents N3 FrostFS SideChain.

Contracts deployed:
- Alphabet (AZ) [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/alphabet)
- Balance [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/balance)
- Container [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/container)
- FrostFS [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/frostfs)
- FrostFSID [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/frostfsid)
- NNS [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/nns)
- Netmap [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/netmap)
- Policy [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/policy)
- Processing [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/processing)
- Proxy [contract](https://git.frostfs.info/TrueCloudLab/frostfs-contract/src/branch/master/proxy)

RPC available at `http://morph-chain.frostfs.devenv:30333`.

## .env settings

### NEOGO_VERSION

Version of neo-go docker container for side chain deployment.

## FrostFS global config

FrostFS uses global configuration to store epoch duration, maximum object size, 
container fee and other network parameters. Global configuration is stored in
netmap contract and managed by Inner Ring (Alphabet) nodes.

To change these parameters use `make update.*` commands. Command down below
changes epoch duration from 300 blocks (about 300 seconds with 1bps) to 30.

```
$ make update.epoch_duration val=30
Waiting for transactions to persist...
```

Read more about available configuration in Makefile help.

```
$ make help
  ...
  Targets:
  ...
    update.audit_fee                     Update audit fee per result in fixed 12 (make update.audit_fee val=100)
    update.basic_income_rate             Update basic income rate in fixed 12 (make update.basic_income_rate val=1000)
    update.container_alias_fee           Update container alias fee per alphabet node in fixed 12 (make update.container_alias_fee val=100)
    update.container_fee                 Update container fee per alphabet node in fixed 12 (make update.container_fee val=500)
    update.eigen_trust_alpha             Update alpha parameter of EigenTrust algorithm in 0 <= f <= 1.0 (make update.eigen_trust_alpha val=0.2)
    update.eigen_trust_iterations        Update amount of EigenTrust iterations (make update.eigen_trust_iterations val=2)
    update.epoch_duration                Update epoch duration in side chain blocks (make update.epoch_duration val=30)
    update.homomorphic_hashing_disable   Update homomorphic hashing disabled flag (make update.homomorphic_hashing_disable val=true)
    update.max_object_size               Update max object size in bytes (make update.max_object_size val=1000)
    update.system_dns                    Update system dns to resolve container names (make update.system_dns val=container)
```
